﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DaHanSmsDemo_CSharp
{
    class Program
    {
        static void Main(string[] args)
        {

            string ret = null;
            string retINT = null;
            SmsSDK smsSDK = new SmsSDK();

            /*
             * 帐户参数配置
             * 用户登录之后在开发者控制台【首页】寻找以下配置参数：
             * AccountSid: 帐号ID，对应开发者帐号下的 ACCOUNT SID
             * AuthToken: 授权令牌，对应开发者帐号下的 AUTH TOKEN
             * ApiUrl: API调用路径，对应着开发者后台中的API URL
             * AppId: 应用ID，对应开发者控制台【应用管理】中的某个APP ID
             */
            smsSDK.setAccountSid("19de688ea3f4461b9963ce**********");
            smsSDK.setAuthToken("92323d68a2964599862cd6**********");
            smsSDK.setApiUrl("https://sms.dahancloud.com/");
            smsSDK.setAppId("e8acc5267b0e4660914f0c**********");
            
            try
            {
                /*
                 * 发送模板短信
                 * 
                 * @param to 手机号码，多个手机号码需用英文逗号分开
                 * @param templateId 模板ID，对应开发者后台中的模板编号
                 * @param datas 替换内容，格式为数组，例如：new String[]{"1238", "3"}, 如果模板中的内容不需要替换，需填null
                 * 
                 * 短信接口调用说明
                 * 
                 * 假设您想给手机号159xxxx1234发送一条短信，
                 * 您打算使用的模板ID为2，对应模板内容为："您好，您的手机验证码为：{1}，{2}分钟内有效"
                 * 给这个模板传入的参数为5678和3，则调用方式为：
                 * sendSMS("159xxxx1234", "2", ['5678','3']);
                 * 最终收到的短信内容为："【云通讯】您好，您的手机验证码为5678，3分钟内有效"
                 */
                Dictionary<string, object> retData = smsSDK.sendSMS("1328653****", "1", new String[] { "1238" });

                /*
                 * 发送国际短信 
                 */
                Dictionary<string, object> retINTData = smsSDK.sendINTSMS("+13252081339", "1", new String[] { "1238" });

                ret = getDictionaryData(retData);

                retINT = getDictionaryData(retINTData);
            }
            catch (Exception e)
            {
                ret = e.Message;
                retINT = e.Message;
            }
            finally
            {
                //国内普通短信发送
                Console.WriteLine(ret);
                //国际短信发送
                Console.WriteLine(retINT);

                Console.ReadKey();
            }
        }

        private static string getDictionaryData(Dictionary<string, object> templateSMS)
        {
            string ret = null;
            foreach (KeyValuePair<string, object> item in templateSMS)
            {
                if (item.Value != null && item.Value.GetType() == typeof(Dictionary<string, object>))
                {
                    ret += item.Key.ToString() + "={";
                    ret += getDictionaryData((Dictionary<string, object>)item.Value);
                    ret += "};";
                }
                else
                {
                    ret += item.Key.ToString() + "=" + (item.Value == null ? "null" : item.Value.ToString()) + ";";
                }
            }
            return ret;
        }
    }
}
